// Copyright (c) 2020, DartRocket authors.
// MIT-style license that can be found in the LICENSE file.

library container.example.start_container;

import 'package:dartrocket_container/container.dart';

class Foo {
  String _foo;

  Foo(String foo) {
    this._foo = foo;
  }

  String readFoo() {
    return _foo;
  }

  void setNewFoo(String newFoo) {
    this._foo = newFoo;
  }
}

void main () {
  Container container = Container();

  container.bind('FooPackage/Foo', () {
    return Foo('Hello World');
  });

  container.singleton('FooPackage/FooSingleton', () {
    return Foo('Hello World Singleton');
  });

  container.alias('FooPackage/FooSingleton', 'FooSingleton');

  Foo foo = container.use('FooPackage/Foo');
  // Hello World
  print(foo.readFoo());
  foo.setNewFoo('New Hello World');
  // New Hello World
  print(foo.readFoo());

  Foo foo2 = container.use('FooPackage/Foo');
  // Hello World
  print(foo2.readFoo());

  Foo fooSingleton = container.use('FooPackage/FooSingleton');
  // Hello World Singleton
  print(fooSingleton.readFoo());
  fooSingleton.setNewFoo('New Hello World Singleton');
  // New Hello World Singleton
  print(foo.readFoo());

  Foo fooSingleton2 = container.use('FooSingleton');
  // New Hello World Singleton
  print(fooSingleton2.readFoo());
}