// Copyright (c) 2020, DartRocket authors.
// MIT-style license that can be found in the LICENSE file.

library dartrocket_container.src.binding;

class Binding {
  Function _closure;
  dynamic _cachedClosure;
  bool _singleton;

  Binding(Function closure, {singleton = false}) {
    this._closure = closure;
    this._singleton = singleton;
  }

  dynamic instance() {
    return this._singleton
        ? this._cachedClosure ??= this._closure()
        : this._closure();
  }
}